# component/bubbles.js

    import * as d3 from "d3";
    import dataTransform from "../dataTransform";
    import { dispatch, attachEventListners } from "../events";
    import { colorParse } from "../colorHelper";

    /**
     * Reusable 3D Bubble Chart Component
     *
     * @module
     */
    export default function() {

    	/* Default Properties */
    	let dimensions = { x: 40, y: 40, z: 40 };
    	let colors = d3.schemeRdYlGn[8];
    	let color;
    	let classed = "d3X3dBubbles";

    	/* Scales */
    	let xScale;
    	let yScale;
    	let zScale;
    	let colorScale;
    	let sizeScale;
    	let sizeRange = [0.5, 4.0];

    	/**
    	 * Initialise Data and Scales
    	 *
    	 * @private
    	 * @param {Array} data - Chart data.
    	 */
    	const init = function(data) {
    		const { valueExtent, coordinatesMax } = dataTransform(data).summary();
    		const { x: maxX, y: maxY, z: maxZ } = coordinatesMax;
    		const { x: dimensionX, y: dimensionY, z: dimensionZ } = dimensions;

    		if (typeof xScale === "undefined") {
    			xScale = d3.scaleLinear()
    				.domain([0, maxX])
    				.range([0, dimensionX]);
    		}

    		if (typeof yScale === "undefined") {
    			yScale = d3.scaleLinear()
    				.domain([0, maxY])
    				.range([0, dimensionY]);
    		}

    		if (typeof zScale === "undefined") {
    			zScale = d3.scaleLinear()
    				.domain([0, maxZ])
    				.range([0, dimensionZ]);
    		}

    		if (typeof sizeScale === "undefined") {
    			sizeScale = d3.scaleLinear()
    				.domain(valueExtent)
    				.range(sizeRange);
    		}

    		if (color) {
    			colorScale = d3.scaleQuantize()
    				.domain(valueExtent)
    				.range([color, color]);
    		} else if (typeof colorScale === "undefined") {
    			colorScale = d3.scaleQuantize()
    				.domain(valueExtent)
    				.range(colors);
    		}
    	};

    	/**
    	 * Constructor
    	 *
    	 * @constructor
    	 * @alias bubbles
    	 * @param {d3.selection} selection - The chart holder D3 selection.
    	 */
    	const my = function(selection) {
    		selection.each(function(data) {
    			init(data);

    			const element = d3.select(this)
    				.classed(classed, true)
    				.attr("id", (d) => d.key);

    			const shape = (el) => {
    				const shape = el.append("Shape");

    				attachEventListners(shape);

    				shape.append("Sphere")
    					.attr("radius", (d) => sizeScale(d.value));

    				shape.append("Appearance")
    					.append("Material")
    					.attr("diffuseColor", (d) => colorParse(colorScale(d.value)))
    					.attr("ambientIntensity", 0.1);

    				return shape;
    			};

    			const bubbles = element.selectAll(".bubble")
    				.data((d) => d.values, (d) => d.key);

    			const bubblesEnter = bubbles.enter()
    				.append("Transform")
    				.attr("class", "bubble")
    				.call(shape)
    				.merge(bubbles)
    				.transition();

    			bubblesEnter
    				.attr("translation", (d) => (xScale(d.x) + " " + yScale(d.y) + " " + zScale(d.z)));

    			bubblesEnter.select("Shape")
    				.select("Appearance")
    				.select("Material")
    				.attr("diffuseColor", (d) => colorParse(colorScale(d.value)));

    			bubblesEnter.select("Shape")
    				.select("Sphere")
    				.attr("radius", (d) => sizeScale(d.value));

    			bubbles.exit()
    				.remove();
    		});
    	};

    	/**
    	 * Dimensions Getter / Setter
    	 *
    	 * @param {{x: number, y: number, z: number}} _v - 3D object dimensions.
    	 * @returns {*}
    	 */
    	my.dimensions = function(_v) {
    		if (!arguments.length) return dimensions;
    		dimensions = _v;
    		return this;
    	};

    	/**
    	 * X Scale Getter / Setter
    	 *
    	 * @param {d3.scale} _v - D3 scale.
    	 * @returns {*}
    	 */
    	my.xScale = function(_v) {
    		if (!arguments.length) return xScale;
    		xScale = _v;
    		return my;
    	};

    	/**
    	 * Y Scale Getter / Setter
    	 *
    	 * @param {d3.scale} _v - D3 scale.
    	 * @returns {*}
    	 */
    	my.yScale = function(_v) {
    		if (!arguments.length) return yScale;
    		yScale = _v;
    		return my;
    	};

    	/**
    	 * Z Scale Getter / Setter
    	 *
    	 * @param {d3.scale} _v - D3 scale.
    	 * @returns {*}
    	 */
    	my.zScale = function(_v) {
    		if (!arguments.length) return zScale;
    		zScale = _v;
    		return my;
    	};

    	/**
    	 * Size Scale Getter / Setter
    	 *
    	 * @param {d3.scale} _v - D3 size scale.
    	 * @returns {*}
    	 */
    	my.sizeScale = function(_v) {
    		if (!arguments.length) return sizeScale;
    		sizeScale = _v;
    		return my;
    	};

    	/**
    	 * Size Range Getter / Setter
    	 *
    	 * @param {number[]} _v - Size min and max (e.g. [1, 9]).
    	 * @returns {*}
    	 */
    	my.sizeRange = function(_v) {
    		if (!arguments.length) return sizeRange;
    		sizeRange = _v;
    		return my;
    	};

    	/**
    	 * Color Scale Getter / Setter
    	 *
    	 * @param {d3.scale} _v - D3 color scale.
    	 * @returns {*}
    	 */
    	my.colorScale = function(_v) {
    		if (!arguments.length) return colorScale;
    		colorScale = _v;
    		return my;
    	};

    	/**
    	 * Color Getter / Setter
    	 *
    	 * @param {string} _v - Color (e.g. "red" or "#ff0000").
    	 * @returns {*}
    	 */
    	my.color = function(_v) {
    		if (!arguments.length) return color;
    		color = _v;
    		return my;
    	};

    	/**
    	 * Colors Getter / Setter
    	 *
    	 * @param {Array} _v - Array of colours used by color scale.
    	 * @returns {*}
    	 */
    	my.colors = function(_v) {
    		if (!arguments.length) return colors;
    		colors = _v;
    		return my;
    	};

    	/**
    	 * Dispatch On Getter
    	 *
    	 * @returns {*}
    	 */
    	my.on = function() {
    		let value = dispatch.on.apply(dispatch, arguments);
    		return value === dispatch ? my : value;
    	};

    	return my;
    }